-- Code by SoundOfSpouting#6980 (UID: 151149148639330304)


entry = bigdiv -- Pointfree!!


bigdiv :: [Double] -> [Double] -> ([Double], [Double])
bigdiv [] _ = ([], [])
bigdiv (head : tail) b = do
    let (div, temp_mod) = bigdiv tail b
    let (x, mod) = smalldiv (head : temp_mod) b
    (x : div, mod)


smalldiv :: [Double] -> [Double] -> (Double, [Double])
smalldiv [] _ = (0, [])
smalldiv x [] = smalldiv x [0] -- Spot the zero division
smalldiv [a] [b] = (a/b, [])
smalldiv (a : ta) (b : tb) = do
    let (q, mod) = smalldiv ta tb
    (q, a - q * b : mod)
